/*
 * The software is provided under the Copyright, 2008.
 * Software Tools Technology Group, Computer Science Dept.,
 * Worcester Polytechnic Institute, sttg@cs.wpi.edu
 *
 * The program is provided under the terms and conditions of
 * the Eclipse Public License Version 1.0 ("EPL"). A copy of the EPL
 * is available at http://www.eclipse.org/org/documents/epl-v10.php.
 *
 * $Id:$
 */
package edu.webfoot.vnc.editor;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * A small dialog box which prompts the user for a password.
 * 
 * @author Ken  Breeman (kbreeman@wpi.edu)
 * @author Eric Griffel (sniffels@wpi.edu)
 */
public class PasswordDialog extends Dialog {
	
	private Text password;
	private String textLabel;
	private String pass;
	
	public PasswordDialog(Shell parentShell, String label) {
		super(parentShell);
		this.textLabel = label;
	}

	protected Control createDialogArea(Composite parent) {
		parent.getShell().setText("Password Dialog");
		Composite comp = (Composite)super.createDialogArea(parent);
		
		comp.setLayout(new GridLayout(2, true));
		Label label = new Label(comp, SWT.RIGHT);
		label.setText(this.textLabel + ": ");
		GridData data = new GridData(SWT.HORIZONTAL, SWT.FILL, false, true);
		label.setLayoutData(data);
		this.password = new Text(comp, SWT.SINGLE | SWT.PASSWORD);
		this.password.setTextLimit(8);
		data = new GridData(SWT.HORIZONTAL, SWT.FILL, false, true);
		this.password.setLayoutData(data);
		
		parent.pack();
		return comp;
	}
	
	protected void buttonPressed(int buttonId) {
	    if (buttonId == IDialogConstants.OK_ID)
	      this.pass = this.password.getText();
	    super.close();
	}
	
	public String getValue() {
		return this.pass;
	}
}
