package gnu.rfb;

/**
 * <br><br><center><table border="1" width="80%"><hr>
 * <strong><a href="http://www.amherst.edu/~tliron/vncj">VNCj</a></strong>
 * <p>
 * Copyright (C) 2000-2002 by Tal Liron
 * <p>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * <p>
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * <a href="http://www.gnu.org/copyleft/lesser.html">GNU Lesser General Public License</a>
 * for more details.
 * <p>
 * You should have received a copy of the <a href="http://www.gnu.org/copyleft/lesser.html">
 * GNU Lesser General Public License</a> along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * <hr></table></center>
 **/

import java.io.DataOutput;
import java.io.IOException;

public class CopyRect extends Rect {

	// The source X and Y coordinates to copy from.
	public int srcX;
	public int srcY;

	/**
	 * Default constructor
	 * 
	 * @param x
	 *            The x-location of the source rectangle
	 * @param y
	 *            The y-location of the source rectangle
	 * @param w
	 *            The width of the source rectangle
	 * @param h
	 *            The height of the source rectangle
	 * @param srcX
	 *            The x-location of the destination rectangle
	 * @param srcY
	 *            The y-location of the destination rectangle
	 */
	public CopyRect(int x, int y, int w, int h, int srcX, int srcY) {
		super(x, y, w, h);
		this.srcX = srcX;
		this.srcY = srcY;
	}

	/**
	 * Writes out a CopyRect message to the given output.
	 * 
	 * @param output
	 *            The output to write to.
	 * @throws IOException
	 *             If unable to write to the output.
	 */
	public void writeData(DataOutput output) throws IOException {
		output.writeInt(RFB.EncodingCopyRect);
		output.writeShort(srcX);
		output.writeShort(srcY);
	}
}
