package gnu.vnc;

/**
 * <br><br><center><table border="1" width="80%">
 * 
 * <p>
 * Copyright (C) 2007-2008 VNCj
 * <p>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * <p>
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * <a href="http://www.gnu.org/copyleft/lesser.html">GNU Lesser General Public License</a>
 * for more details.
 * <p>
 * You should have received a copy of the <a href="http://www.gnu.org/copyleft/lesser.html">
 * GNU Lesser General Public License</a> along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * <hr></table></center>
 **/

/**
 * Provides logging facilities for users and developers.
 * 
 * @author rpatel
 * 
 * Modified by:
 * Ken  Breeman (kbreeman@wpi.edu)
 * Eric Griffel (sniffles@wpi.edu)
 * 
 */
public class VLogger {

	/* */
	static private VLogger instance = null;

	/**
	 * Creates a new instance of Class
	 */
	protected VLogger() {
	}

	/**
	 * 
	 * @param msg
	 */
	public void log(String msg) {
		System.out.println(msg);
	}

	/**
	 * 
	 * @param msg
	 * @param t
	 */
	public void log(String msg, Throwable t) {
		System.out.println(msg);
		t.printStackTrace();
	}

	/**
	 * 
	 * @return
	 */
	static public VLogger getLogger() {
		if (instance == null) {
			instance = new VLogger();
		}
		return instance;
	}

	/**
	 * 
	 * @param newInstance
	 */
	static public void setLogger(VLogger newInstance) {
		instance = newInstance;
	}

}
