/**
 * <br><br><center><table border="1" width="80%"><hr>
 * <strong><a href="http://www.amherst.edu/~tliron/vncj">VNCj</a></strong>
 * <p>
 * Copyright (C) 2000-2002 by Tal Liron
 * <p>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * <p>
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * <a href="http://www.gnu.org/copyleft/lesser.html">GNU Lesser General Public License</a>
 * for more details.
 * <p>
 * You should have received a copy of the <a href="http://www.gnu.org/copyleft/lesser.html">
 * GNU Lesser General Public License</a> along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * <hr></table></center>
 **/
package gnu.vnc.pixels;

import gnu.rfb.Colour;
import gnu.rfb.PixelFormat;
import gnu.rfb.server.RFBClient;
import gnu.rfb.server.RFBClients;
import gnu.rfb.server.RFBServer;
import gnu.rfb.server.VNCQueue;
import gnu.vnc.awt.PixelsOwner;

import java.io.IOException;
import java.util.Enumeration;

/**
 * 
 * @author Tal Liron
 */
public class VNCPixels implements RFBServer, PixelsOwner {

	/* */
	private String name;
	
	/* */
	private int width;
	
	/* */
	private int height;
	
	/* */
	private RFBClients clients = new RFBClients();
	
	/* */
	private boolean shared = false;
	
	/* */
	private int[] pixelArray = null;
	
	/* */
	protected VNCQueue queue;


	/**
	 * VNCEvents to forward events to
	 */
	private gnu.vnc.awt.VNCEvents events = null;

	public void setVNCEventsHandler(gnu.vnc.awt.VNCEvents events) {
		this.events = events;
	}

	/**
	 * 
	 * @return
	 */
	public gnu.vnc.awt.VNCEvents getVNCEventsHandler() {
		return events;
	}

	/**
	 * 
	 * @param name
	 * @param width
	 * @param height
	 */
	public VNCPixels(String name, int width, int height) {
		this.name = name;
		this.width = width;
		this.height = height;

		queue = new VNCQueue(clients);

		pixelArray = new int[width * height];
	}

	/**
	 * externalize queue to manually add entries
	 * 
	 * @return
	 */
	public VNCQueue getQueue() {
		return (queue);
	}

	/*
	 * 
	 */
	public void dispose() {
	}

	/**
	 * 
	 */
	public void addClient(RFBClient client) {
		clients.addClient(client);
	}

	/**
	 * 
	 * @return
	 */
	public RFBClients getClients() {
		return (clients);
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#removeClient(gnu.rfb.server.RFBClient)
	 */
	public void removeClient(RFBClient client) {
		clients.removeClient(client);
		if (clients.isEmpty() && !shared) {
			clients.closeAll();
			dispose();
		}
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#getDesktopName(gnu.rfb.server.RFBClient)
	 */
	public String getDesktopName(RFBClient client) {
		return name;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#getFrameBufferWidth(gnu.rfb.server.RFBClient)
	 */
	public int getFrameBufferWidth(RFBClient client) {
		return width;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#getFrameBufferHeight(gnu.rfb.server.RFBClient)
	 */
	public int getFrameBufferHeight(RFBClient client) {
		return height;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#getPreferredPixelFormat(gnu.rfb.server.RFBClient)
	 */
	public PixelFormat getPreferredPixelFormat(RFBClient client) {
		return PixelFormat.RGB888;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#allowShared()
	 */
	public boolean allowShared() {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#setClientProtocolVersionMsg(gnu.rfb.server.RFBClient, java.lang.String)
	 */
	public void setClientProtocolVersionMsg(RFBClient client, String protocolVersionMsg) throws IOException {
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#setShared(gnu.rfb.server.RFBClient, boolean)
	 */
	public void setShared(RFBClient client, boolean shared) throws IOException {
		if (shared)
			this.shared = true;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#setPixelFormat(gnu.rfb.server.RFBClient, gnu.rfb.PixelFormat)
	 */
	public void setPixelFormat(RFBClient client, PixelFormat pixelFormat) throws IOException {
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#setEncodings(gnu.rfb.server.RFBClient, int[])
	 */
	public void setEncodings(RFBClient client, int[] encodings) throws IOException {
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#fixColourMapEntries(gnu.rfb.server.RFBClient, int, gnu.rfb.Colour[])
	 */
	public void fixColourMapEntries(RFBClient client, int firstColour, Colour[] colourMap) throws IOException {
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#frameBufferUpdateRequest(gnu.rfb.server.RFBClient, boolean, int, int, int, int)
	 */
	public void frameBufferUpdateRequest(RFBClient client, boolean incremental, int x, int y, int w, int h) throws IOException {
		queue.takeSnapshot(this);
		queue.frameBufferUpdate(client, incremental, x, y, w, h);
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#keyEvent(gnu.rfb.server.RFBClient, boolean, int)
	 */
	public void keyEvent(RFBClient client, boolean down, int key) throws IOException {
		// System.err.println("DEBUG[VNCPixels] keyEvent");
		if (events != null) {
			events.translateKeyEvent(client, down, key);
		} else {
			updateAll();
		}
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#pointerEvent(gnu.rfb.server.RFBClient, int, int, int)
	 */
	public void pointerEvent(RFBClient client, int buttonMask, int x, int y) throws IOException {
		// System.err.println("DEBUG[VNCPixels] pointerEvent");
		if (events != null) {
			events.translatePointerEvent(client, buttonMask, x, y);
		} else {
			updateAll();
		}
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.rfb.server.RFBServer#clientCutText(gnu.rfb.server.RFBClient, java.lang.String)
	 */
	public void clientCutText(RFBClient client, String text) throws IOException {
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.awt.PixelsOwner#getPixels()
	 */
	public int[] getPixels() {
		return pixelArray;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.awt.PixelsOwner#setPixelArray(int[], int, int)
	 */
	public void setPixelArray(int[] pixelArray, int pixelWidth, int pixelHeight) {
		this.pixelArray = pixelArray;
		this.width = pixelWidth;
		this.height = pixelHeight;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.awt.PixelsOwner#getPixelWidth()
	 */
	public int getPixelWidth() {
		return width;
	}

	/*
	 * (non-Javadoc)
	 * @see gnu.awt.PixelsOwner#getPixelHeight()
	 */
	public int getPixelHeight() {
		return height;
	}

	/*
	 * 
	 */
	public void updateAll() throws IOException {
		for (Enumeration e = clients.elements(); e.hasMoreElements();) {
			RFBClient client = (RFBClient) e.nextElement();
			frameBufferUpdateRequest(client, false, 0, 0, width, height);
		}
	}

}
